using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Data;

namespace DBControls
{
	/// <summary>
	/// Summary description for frmQueryWriter.
	/// </summary>
	public class QueryWriter : System.Windows.Forms.UserControl
	{
		public System.Windows.Forms.RichTextBox rtbQueryPad;
		private System.Windows.Forms.Panel pnlQuery;
		public System.Windows.Forms.DataGrid dgResult;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>

		private System.ComponentModel.Container components = null;
		private static int buttonIndex=0;

		// add the keywords in this array to highlight it
		String [] keywords = { "select", "insert", "update", "delete", "inner", "join",
								 "right","left","into","from","go" }; 

		int BUTTON_LEFT_DELTA = 72;		
		private System.Windows.Forms.TabControl tabResult;
		private System.Windows.Forms.TabPage tabPage0;
		int BUTTON_LEFT_CONST = 72;

		public QueryWriter()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(QueryWriter));
			this.pnlQuery = new System.Windows.Forms.Panel();
			this.rtbQueryPad = new System.Windows.Forms.RichTextBox();
			this.dgResult = new System.Windows.Forms.DataGrid();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.tabResult = new System.Windows.Forms.TabControl();
			this.tabPage0 = new System.Windows.Forms.TabPage();
			this.pnlQuery.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dgResult)).BeginInit();
			this.tabResult.SuspendLayout();
			this.tabPage0.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlQuery
			// 
			this.pnlQuery.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pnlQuery.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlQuery.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.rtbQueryPad});
			this.pnlQuery.Name = "pnlQuery";
			this.pnlQuery.Size = new System.Drawing.Size(768, 296);
			this.pnlQuery.TabIndex = 0;
			// 
			// rtbQueryPad
			// 
			this.rtbQueryPad.AcceptsTab = true;
			this.rtbQueryPad.Dock = System.Windows.Forms.DockStyle.Fill;
			this.rtbQueryPad.Name = "rtbQueryPad";
			this.rtbQueryPad.Size = new System.Drawing.Size(764, 292);
			this.rtbQueryPad.TabIndex = 2;
			this.rtbQueryPad.Text = "";
			this.rtbQueryPad.TextChanged += new System.EventHandler(this.rtbQueryPad_TextChanged);
			// 
			// dgResult
			// 
			this.dgResult.DataMember = "";
			this.dgResult.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgResult.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgResult.Name = "dgResult";
			this.dgResult.Size = new System.Drawing.Size(760, 230);
			this.dgResult.TabIndex = 6;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 562);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(768, 3);
			this.splitter1.TabIndex = 7;
			this.splitter1.TabStop = false;
			// 
			// tabResult
			// 
			this.tabResult.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.tabPage0});
			this.tabResult.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.tabResult.Location = new System.Drawing.Point(0, 306);
			this.tabResult.Name = "tabResult";
			this.tabResult.SelectedIndex = 0;
			this.tabResult.Size = new System.Drawing.Size(768, 256);
			this.tabResult.TabIndex = 1;
			// 
			// tabPage0
			// 
			this.tabPage0.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.dgResult});
			this.tabPage0.Location = new System.Drawing.Point(4, 22);
			this.tabPage0.Name = "tabPage0";
			this.tabPage0.Size = new System.Drawing.Size(760, 230);
			this.tabPage0.TabIndex = 0;
			this.tabPage0.Text = "Result 0";
			// 
			// frmQueryWriter
			// 
			this.ClientSize = new System.Drawing.Size(768, 565);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabResult,
																		  this.splitter1,
																		  this.pnlQuery});
			this.Name = "frmQueryWriter";
			this.Text = "Query Writer";
			this.Load += new System.EventHandler(this.frmQueryWriter_Load);
			this.pnlQuery.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dgResult)).EndInit();
			this.tabResult.ResumeLayout(false);
			this.tabPage0.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Creates dynamic grids in the output windows based on no. of queries
		/// </summary>
		/// <param name="dt">the datatable </param>
		public void  RenderGrid(DataTable dt)
		{
			
			if (buttonIndex == 0)	// 0 the query
			{
				this.dgResult.DataSource = dt;	
				buttonIndex++;
				return;
			}
			
			tabResult.Controls.Add(new TabPage("Result " + buttonIndex.ToString()));
			tabResult.TabPages[tabResult.TabPages.Count-1].Name = "tabPages"+ buttonIndex.ToString();

			CreateGridInTabControl(dt, "dgResult" + buttonIndex.ToString());
			buttonIndex++;
		}
		
		/// <summary>
		/// This code actually creates the grid control in the output window
		/// </summary>
		/// <param name="dt">the datatable </param>
		/// <param name="gridName">the grid name</param>
		public void CreateGridInTabControl(System.Data.DataTable dt, string gridName)
		{
			System.Windows.Forms.DataGrid dg = new System.Windows.Forms.DataGrid ();
			dg.Name = gridName;

			dg.DataSource = dt;
		
			dg.Top = dgResult.Top;
			dg.Left = dgResult.Left;
			dg.Anchor = dgResult.Anchor;
			dg.Dock = dgResult.Dock;
			dg.Width = dgResult.Width;
			dg.Height = dgResult.Height;

			tabResult.TabPages[tabResult.TabPages.Count-1].Controls.Add(dg);
		}

		public void ResetButtonIndex()
		{
			buttonIndex = 0;
			BUTTON_LEFT_DELTA = BUTTON_LEFT_CONST ;
		}
		
		//handler for Button click (result)
		// This function is not yet used
		private void btnTable0_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(((System.Windows.Forms.Button)(sender)).Tag.ToString());		

			DataGrid dg;
			dg = (DataGrid)GetControl(((System.Windows.Forms.Button)(sender)).Tag.ToString());

			if (null == dg)
			{}
			else
			{
				dg.BringToFront();
			}
		}

		
		public void DisposeTabPages()
		{
			foreach(TabPage tp in tabResult.TabPages)
			{
				if (tp.Name != "tabPage0")
				{
					tabResult.TabPages.Remove(tp);
				}
			}
		}
		
		// This function is not yet used 
		private Control GetControl(string controlName )
		{
			foreach  (Control grid in this.Controls)
			{
				if (null==grid) continue;
				
				if (grid.GetType().Name == "DataGrid")
				{
					if (grid.Name == controlName)
						return grid;
				}
			}
			return null;
		}

		private void frmQueryWriter_Load(object sender, System.EventArgs e)
		{
		
		}
		private void rtbQueryPad_TextChanged(object sender, System.EventArgs e)
		{
			// Split the line into tokens.
			Regex r = new Regex("([ \\t{}();])");
			string [] tokens = r.Split(rtbQueryPad.Text);
			foreach (string token in tokens) 
			{
				for (int i = 0; i < keywords.Length; i++) 
				{
					if (keywords[i] == token) 
					{
						FindAndHighlight(token,Color.Blue,true,true);
						break;
					}
				}
			}
		} 
		
		/// <summary>
		/// Finds and highlighs the keywords
		/// </summary>
		/// <param name="SearchText"></param>
		/// <param name="HighlightColor"></param>
		/// <param name="MatchCase"></param>
		/// <param name="WholeWords"></param>
		private void FindAndHighlight(string SearchText , Color HighlightColor, bool MatchCase ,bool WholeWords )
		{

			int StartLooking = 0;
			int FoundAt ;
			int SearchLength; 
			
			int CurrentSelectionStart = rtbQueryPad.SelectionStart;
			int CurrentSelectionLength = rtbQueryPad.SelectionLength;

			RichTextBoxFinds RTBfinds; 
			
			if (SearchText == string.Empty) return;
        
			if (MatchCase && WholeWords) 
				RTBfinds = RichTextBoxFinds.MatchCase | RichTextBoxFinds.WholeWord;
			else	
				if (MatchCase)
				RTBfinds = RichTextBoxFinds.MatchCase;
			else				
				if (WholeWords)
				RTBfinds = RichTextBoxFinds.WholeWord;
			else		
				RTBfinds = RichTextBoxFinds.None;
			
			SearchLength = SearchText.Length;
			do
			{
				try
				{
					FoundAt = rtbQueryPad.Find(SearchText, StartLooking, RTBfinds);
					if(FoundAt > -1) rtbQueryPad.SelectionColor = HighlightColor;
					StartLooking = StartLooking + SearchLength ;
				}
				catch(Exception ex)
				{
					System.Diagnostics.Debug.WriteLine(ex.Message);
					FoundAt = -1;
				}
			}while (FoundAt > -1);
			
			rtbQueryPad.SelectionStart = CurrentSelectionStart;
			rtbQueryPad.SelectionLength = 0;
			rtbQueryPad.SelectionColor = Color.Black;

		}
	}

	
}

